
from numpy import sin, zeros, mean
from numpy.random import randn

"""
Python is based on "Object-oriented programming technique. All modules require
classes and functions in order for you to re use them with your own user defined
variables. A class = a Blueprint(template) of an Object (i.e; Student). The attributes = Characteristics
i.e; the student has: name, gender, ID, grades, attendance
The method/functions of the class help us compute/define what the values of
these characteristics/attributes are i.e; def addGradeToStudent etc.
"""

class Signals():
    """
    Here we always add the constructor line (def __init__(**params))to initiate the "constructor method"
    of Object-Oriented Programming  
    """  
    def __init__(self,name):
        """        
        Here we list all attributes. Remember "self" will be replaced by the name of the object (i.e instance of the class)
        Which you create in your program i.e; signal1 = Signal("x"). Therefore self = signal1 on execution
        of this class
        """
        self.name = name        
        self.signal1 = [] 
        self.signal2 = []
        self.Rxy = []
    """       
    Here we define all methods/functions associated to attributes of the class. Therefore
    we are using these methods to calculate or define the particular attributes of the class 
    i.e; "def SinNormal" would calculate and return a sin signal with noise to be used under the
    attribute of signal1 which is an attribute of whole class of Signals. 
    """
    def SinWithNoise(self,t):
        self.signal1 = 20*sin(0.15*t) + randn(1)
        return self.signal1

    def SinNormal(self,t):
        self.signal2 = 10+20*sin(0.15*t)
        return self.signal2
    
    def corrcoeff(self,x,y,meany,stdy,meanx,stdx):
        R = zeros(len(y))
        for k in range(0,len(y)):
            R[k] = mean(((x[k]-meanx)/stdx)*((y[k]-meany)/stdy))
            self.Rxy.append(R[k])
        return R
  

