
#from numpy import min, max
from numpy import asarray, loadtxt
from scipy.signal import lti, dlsim, lsim, step, impulse
from scipy import linspace
from matplotlib.pyplot import figure, plot, subplot, grid, show

#==============================================================================
# Simple Simulations of Transfer Functions - step, impulse etc.
#==============================================================================


"""
tf = (6.3223 s^2 + 18 s +12.811) / (s^4 + 6 s^3 + 11.3223 s^2 + 18s + 12.811)
"""
num = [6.3223, 18, 12.811] 
den = [1, 6, 11.3223, 18, 12.811]

tf = asarray([num, den])

#t, s = step(tf, T = linspace(min(t), t[-1], 500)) 
#
#t, i = impulse(tf, T = linspace(min(t), t[-1], 500))

#figure()
#subplot(111)
#plot(t, i,'r')
#plot(t, s,'b'), grid()
#show()

#==============================================================================
# Simulation of control loop
#==============================================================================

#t_in = [0.0, 1.0, 2.0, 3.0]
#u = asarray([0.0, 1.0, 0.0, -1.0])
u = loadtxt('d.txt')
t_in = linspace(0,len(u),len(u))

y = lsim(tf, u, t_in,0)
t_out = y[0]

figure()
subplot(111)
plot(t_out, u)
plot(t_out, y[1], 'g'), grid()
show()