# -*- coding: utf-8 -*-
"""
Created on Thu Apr 24 20:47:04 2014

@author: Administrator
"""
from numpy import sin, pi
from scipy import linspace
from scipy.integrate import odeint
from matplotlib.pyplot import figure, plot, grid, show, title, subplot

t = linspace (0,201,201)
u=1 # step

def plant(y,t):
    tau = 2
    dydt = (1.0/tau)*(u-y)
    return dydt
    
y = odeint(plant,0,t)

figure()
subplot(111)
plot(t, y,'b'),grid()
show()
    
# for 2nd Order Processes - e.g. Simple Pendulum

def pend_int(initial, t):
    theta = initial[0]
    omega = initial[1]
    g = 9.81
    L = 0.2
    f = [omega, -(g/L)*sin(theta)]
    return f
    
t = linspace(0,20,200)

initial = [10*2*pi/360, 0]

pend_sol = odeint(pend_int, initial, t)

figure()
subplot(111)
plot(pend_sol), title('green = omega v t, blue = theta vs t'), grid()
show()

    
    