
import wx
from numpy import sin, cos, pi, zeros, linspace
from matplotlib.pyplot import figure, plot, subplot, grid, show, title, xlabel, ylabel

class PageOne(wx.Panel):
    def __init__(self,parent):
        wx.Panel.__init__(self,parent)
        
        panel12 = wx.Panel(self, -1, pos=(5,5),size=(350,400),style= wx.BORDER_SUNKEN)

        Title1 = wx.StaticText(panel12, label='A=', pos=(5,20))
        self.text1 = wx.TextCtrl(panel12, -1, pos=(5,50),size=(100,30),value='5')
        Title2 = wx.StaticText(panel12, label='Frequency=', pos=(5,100))        
        self.text2 = wx.TextCtrl(panel12, -1, pos=(5,130),size=(100,30),value='1.2')
        button1 = wx.Button(panel12,label="Plot Sin Function",pos=(90,220),size=(150,40))
        self.Bind(wx.EVT_BUTTON, self.sinus, button1)
        
    def sinus(self,event):
        
        A = int(self.text1.GetValue())
        w = float(self.text2.GetValue())
        t = linspace(0,10,100)
        y = zeros(len(t))
        
        for k in range(0,len(t)):
            y[k] = A*sin(w*t[k])
            
        figure()
        subplot(111)
        plot(t,y), grid(), xlabel('time'), ylabel('output value'), title('A*sin(wt)')
        show()

class PageTwo(wx.Panel):
    def __init__(self,parent):
        wx.Panel.__init__(self,parent)
        
        panel12 = wx.Panel(self, -1, pos=(5,5),size=(350,400),style= wx.BORDER_SUNKEN)
        
        Title1 = wx.StaticText(panel12, label='A=', pos=(5,20))
        self.text1 = wx.TextCtrl(panel12, -1, pos=(5,50),size=(100,30),value='5')
        Title2 = wx.StaticText(panel12, label='Frequency=', pos=(5,100))        
        self.text2 = wx.TextCtrl(panel12, -1, pos=(5,130),size=(100,30),value='1.2')
        button1 = wx.Button(panel12,label="Plot Cos Function",pos=(90,220),size=(150,40))
        self.Bind(wx.EVT_BUTTON, self.cosine, button1)
        
    def cosine(self,event):
        
        A = int(self.text1.GetValue())
        w = float(self.text2.GetValue())
        t = linspace(0,10,100)
        y = zeros(len(t))
        
        for k in range(0,len(t)):
            y[k] = A*cos(w*t[k])
            
        figure()
        subplot(111)
        plot(t,y), grid(), xlabel('time'), ylabel('output value'), title('A*cos(wt)')
        show()


class console(wx.Frame):
    def __init__(self,parent,id,title):
        wx.Frame.__init__(self,parent,id,title,size=(380,450),style= wx.SYSTEM_MENU | wx.CAPTION | wx.CLOSE_BOX)

#        ico = wx.Icon('logo.ico', wx.BITMAP_TYPE_ICO)
#        self.SetIcon(ico)
        
        panel1 = wx.Panel(self)
        nb = wx.Notebook(panel1)

        page1 = PageOne(nb)
        page2 = PageTwo(nb)

        nb.AddPage(page1, "Page 1")
        nb.AddPage(page2, "Page 2")

        sizer = wx.BoxSizer()
        sizer.Add(nb, 1, wx.EXPAND)
        panel1.SetSizer(sizer)

app = wx.App()
frame = console(None,-1,"PVVR - Trigonometric Function Plotter")
frame.Show()
app.MainLoop() 