# Lesson 7 - Image Processing with Open CV Python

import cv2
from numpy import *
from matplotlib.pyplot import *

#Scaling + Translation of an Image

img = cv2.imread('sudoku.jpg',0)
rows,cols = img.shape[:2]

print img.shape

#height, width = img.shape[:2]
#res = cv2.resize(img,(2*width, 2*height), interpolation = cv2.INTER_CUBIC)

# We must define the translation Matrix where Tx, Ty corresponding to the 
#last column, denotes the X,Y translation in coordinates.

M = float32([[1,0,100],[0,1,50]])
dst = cv2.warpAffine(img,M,(cols,rows))

#<type 'float'>
#58682.7578125
#<type 'numpy.float32'>
#58682.8


cv2.imshow('img',dst)
cv2.waitKey(0)
#cv2.destroyAllWindows()

# Image Rotation
# cv2.getRotationMatrix2D(image_center,angle,1.0)

M2 = cv2.getRotationMatrix2D((cols/2,rows/2),90,1)
dst2 = cv2.warpAffine(img,M2,(cols,rows))

cv2.imshow('img',dst2)
cv2.waitKey(0)

# Image Gradients - Filtering of an Image

laplacian = cv2.Laplacian(img,cv2.CV_64F)
sobelx = cv2.Sobel(img,cv2.CV_64F,1,0,ksize=5)
sobely = cv2.Sobel(img,cv2.CV_64F,0,1,ksize=5)

figure()
subplot(221)
imshow(img, cmap = 'gray'), title('Original'),xticks([]),yticks([])
subplot(222)
imshow(laplacian,cmap = 'gray'), title('Laplacian'),xticks([]),yticks([])
subplot(223)
imshow(sobelx,cmap = 'gray'),title('Sobel X'), xticks([]),yticks([])
subplot(224)
imshow(sobely,cmap = 'gray'),title('Sobel Y'),xticks([]), yticks([])
show()

# Matching Template Algorithm

img2 = cv2.imread('messi.jpg',0)
template = cv2.imread('ball.jpg',0)
w, h = template.shape[::-1]

# All the 6 methods for comparison in a list
#methods = 'cv2.TM_CCOEFF', 'cv2.TM_CCOEFF_NORMED', 'cv2.TM_CCORR',
#'cv2.TM_CCORR_NORMED', 'cv2.TM_SQDIFF', 'cv2.TM_SQDIFF_NORMED'

# Apply template Matching
res = cv2.matchTemplate(img2,template,cv2.TM_CCOEFF_NORMED)
min_val, max_val, min_loc, max_loc = cv2.minMaxLoc(res)

# If the method is TM_SQDIFF or TM_SQDIFF_NORMED, it takes the min_loc as the
# top_left corner

top_left = max_loc
bottom_right = (top_left[0] + w, top_left[1] + h)

cv2.rectangle(img2,top_left, bottom_right, (0, 255, 0), 3) #args(image,left corner,right corner, BGR color mapping, Thickness)

figure()
subplot(121)
imshow(res,cmap = 'gray'),title('Matching Result'), xticks(), yticks()
subplot(122),
imshow(img2,cmap = 'gray'),title('Detected Point'),xticks([]),yticks([])
show()
