#Control of HC-SR04 Ultrasonic Sensor

import time
import RPi.GPIO as GPIO

#==========================================================
def Read():
  # This function measures a distance
  GPIO.output(Trig, True)
  time.sleep(0.00001)
  GPIO.output(Echo, False)
  start = time.time()

  while GPIO.input(Echo)==0:
    On = time.time()
  while GPIO.input(Echo)==1:
    Off = time.time()
  Int = Off-On
  dist = (Int*340290)/2 #conversion to dist. in mm
  return dist

def mean():
  # Mean for better accuracy
  dist1=measure()
  time.sleep(0.1)
  dist2=measure()
  time.sleep(0.1)
  dist3=measure()
  dist = (dist1 + dist2 + dist3)/3
  return dist
#==========================================================

# For GPIO reference
GPIO.setmode(GPIO.BCM)

# Define GPIO to use on Pi
Trig = 23
echo = 24

print "Start Measurement"

# Setting Input and Output Pins 
GPIO.setup(Trig,GPIO.OUT)  # Trigger
GPIO.setup(echo,GPIO.IN)      # Echo

# Set trigger to False (Low)
GPIO.output(Trig, False)

#For continous looping of measurement
try:
  while GPIO.output(Trig, True):

    dist = mean()
    print "Ball Height : %.1f" % dist
    time.sleep(0.5)

except KeyboardInterrupt:
  # Terminate Measurement
  GPIO.cleanup()
